'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelTemplate = require('babel-template');

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

var _babelPluginSyntaxDynamicImport = require('babel-plugin-syntax-dynamic-import');

var _babelPluginSyntaxDynamicImport2 = _interopRequireDefault(_babelPluginSyntaxDynamicImport);

var _babelTypes = require('babel-types');

var types = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var IMPORT = 'Import';
var AWAIT = 'AwaitExpression';
var CALL = 'CallExpression';

var generateSourceNode = function generateSourceNode(node) {
  var astNode = node[0];
  var path = types.templateLiteral([types.templateElement({ raw: '' }), types.templateElement({ raw: '' }, true)], node);
  if (types.isStringLiteral(astNode) || types.isTemplateLiteral(astNode)) {
    path = node;
  }
  return path;
};

var buildImport = (0, _babelTemplate2.default)('\n  require(sourcePath)\n');

exports.default = function () {
  return {
    inherits: _babelPluginSyntaxDynamicImport2.default,
    visitor: {
      Program: {
        enter: function enter(path) {
          var _path$traverse;

          path.traverse((_path$traverse = {}, _defineProperty(_path$traverse, AWAIT, function (path) {
            if (path.node.argument.type === CALL && path.node.argument.callee.type === IMPORT) {
              var sourcePath = generateSourceNode(path.node.argument.arguments);
              path.replaceWith(buildImport({ sourcePath: sourcePath }));
            }
          }), _defineProperty(_path$traverse, CALL, function (path) {
            if (path.node.callee.type === IMPORT) {
              var sourcePath = generateSourceNode(path.node.arguments);
              path.replaceWith(buildImport({ sourcePath: sourcePath }));
            }
          }), _path$traverse));
        }
      }
    }
  };
};